# -*- encoding: utf-8 -*-
import os
import sys
import email
import errno
import mimetypes
import shutil

def getCoding(strInput):
    '''
    获取编码格式
    '''
    if isinstance(strInput, unicode):
        return "unicode"
    try:
        strInput.decode("utf8")
        return 'utf8'
    except:
        pass
    try:
        strInput.decode("gb2312")
        return 'gb2312'
    except:
        pass

def eml2html(emlpath,htmlpath,attachmentpath):
    fp = open(emlpath, "r")
    msg = email.message_from_file(fp)
    # 循环信件中的每一个mime的数据块
    code=getCoding(attachmentpath)
    if code=='utf8':
        ufname=attachmentpath
    elif code=='gb2312':
        gfname=attachmentpath.decode('gb2312')
        ufname=gfname.encode('utf-8')
    else:
        ufname=attachmentpath
    p=os.path.join(ufname,'readme')
    fr=open(p,'w')
    data='Date$$$:'+msg.get('Date')+'\n'
    fr.write(data)
    data=""
    From=msg.get('From')
    if From.find('<')!=-1:
        [Fromname,Fromaddr]=From.split('<')
        h=email.Header.Header(Fromname)
        dh=email.Header.decode_header(h)
        subject=dh[0][0]
        c=getCoding(subject)
        if c=='gb2312':
            sd=subject.decode('gb2312')
            data='From$$$:'+sd.encode('utf-8')+' <'+Fromaddr+'\n'
        else:
            sd=subject.decode('utf-8')
            data='From$$$:'+sd.encode('utf-8')+' <'+Fromaddr+'\n'
    else:
        data='From$$$:'+From+'\n'
    fr.write(data)
    data=""
    From=msg.get('To')
    Fromline=From.splitlines(False)
    From =""
    for i in range(0,len(Fromline)):
        From=From+' '+Fromline[i]
    Fromline=From.split(',')
    for i in range(0,len(Fromline)):
        FromBuff=Fromline[i]
        if FromBuff.find('<')!=-1:
            [Fromname,Fromaddr]=FromBuff.split('<')
            h=email.Header.Header(Fromname)
            dh=email.Header.decode_header(h)
            subject=dh[0][0]
            c=getCoding(subject)
            if c=='gb2312':
                sd=subject.decode('gb2312')
                data+=sd.encode('utf-8')+' <'+Fromaddr+'\n'
                if Fromaddr.find(',')!=-1:
                    data+='\n'
            else:
                sd=subject.decode('utf-8')
                data+=sd.encode('utf-8')+' <'+Fromaddr+'\n'
        else:
            data+=From+'\n'
    data='From$$$:'+data
    fr.write(data)
    From= msg.get('Cc')
    if From:
        Fromline=From.splitlines(False)
        From =""
        for i in range(0,len(Fromline)):
            From=From+' '+Fromline[i]
        Fromline=From.split(',')
        for i in range(0,len(Fromline)):
            FromBuff=Fromline[i]
            if FromBuff.find('<')!=-1:
                [Fromname,Fromaddr]=FromBuff.split('<')
                h=email.Header.Header(Fromname)
                dh=email.Header.decode_header(h)
                subject=dh[0][0]
                c=getCoding(subject)
                if c=='gb2312':
                    sd=subject.decode('gb2312')
                    data+=sd.encode('utf-8')+' <'+Fromaddr+'\n'
                    if Fromaddr.find(',')!=-1:
                        data+='\n'
                else:
                    sd=subject.decode('utf-8')
                    data+=sd.encode('utf-8')+' <'+Fromaddr+'\n'
            else:
                data+=From+'\n'
        data='Cc$$$:'+data
    else:
        data='Cc$$$:None'+'\n'
    fr.write(data)
    subject=msg.get('subject')
    h=email.Header.Header(subject)
    dh=email.Header.decode_header(h)
    subject=dh[0][0]
    c=getCoding(subject)
    if c=='gb2312':
        sd=subject.decode('gb2312')
        data='Subject$$$:'+sd.encode('utf-8')+'\n'
    else:
        sd=subject.decode('utf-8')
        data='Subject$$$:'+sd.encode('utf-8')+'\n'
    fr.write(data)
    for par in msg.walk():
        if not par.is_multipart(): # 这里要判断是否是multipart，是的话，里面的数据是无用的，至于为什么可以了解mime相关知识。
            # cname = par.get_param("name") #如果是附件，这里就会取出附件的文件名
            name = par.get_filename()
            if name:
                #有附件
                # 下面的三行代码只是为了解码象=?gbk?Q?=CF=E0=C6=AC.rar?=这样的文件名
                h = email.Header.Header(name)
                dh = email.Header.decode_header(h)
                fname = dh[0][0]
                data = par.get_payload(decode=True) #　解码出附件数据，然后存储到文件中
                # fpath=os.path.join(attachmentpath,fname)
                code=getCoding(fname)
                if code=='utf8':
                    ufname=fname
                elif code=='gb2312':
                    gfname=fname.decode('gb2312')
                    ufname=gfname.encode('utf-8')
                else:
                    ufname=fname
                fpath=os.path.join(attachmentpath,ufname)
                f = open(fpath, 'wb') #注意一定要用wb来打开文件，因为附件一般都是二进制文件
                f.write(data)
                f.close()
                fpath=os.path.join(attachmentpath,'readme')
                data='---START---'+'\n'
                fr.write(data)
                data='fileName$$$:'+ufname+'\n'
                fr.write(data)
                if par.get('Content-ID'):
                    data='Content-ID$$$:'+par.get('Content-ID')+'\n'
                else:
                    data='Content-ID$$$:NONE'+'\n'
                fr.write(data)
                if par.get_content_type():
                    data='Content-Type$$$:'+par.get_content_type()+'\n'
                else:
                    data='Content-Type$$$:NONE'+'\n'
                fr.write(data)
                if par.get('Content-Transfer-Encoding'):
                    data='Content-Transfer-Encoding$$$:'+par.get('Content-Transfer-Encoding')+'\n'
                else:
                    data='Content-Transfer-Encoding$$$:NONE'+'\n'
                fr.write(data)
                if par.get('Content-Disposition'):
                    data='Content-Disposition$$$:'+par.get('Content-Disposition')+'\n'
                else:
                    data='Content-Disposition$$$:NONE'+'\n'
                fr.write(data)
                data='---END---'+'\n'
                fr.write(data)
            else:
                #不是附件，是文本内容
                data=par.get_payload(decode=True) # 解码出文本内容，直接输出来就可以了。
                f=open(htmlpath,'wb')
                f.write(data)
                f.close()
    fr.close()
    return

# def pst2html(pstpath,htmlpath):
#     fd=open(pstpath,"r")
#     msg=email.message_from_file(fd)
#     fd.close()
#     for par in msg.walk():
#         if par.get_content_maintype()=="multipart":
#             continue
#         filename=par.get_filename()
#         print filename
#         if not filename:
#             # ext=mimetypes.guess_extension(par.get_content_type())
#             # if not ext:
#             #     ext='.bin'
#             # # print ext
#             fp=open(htmlpath,'wb')
#             fp.write(par.get_payload(decode=True))
#             fp.close()
#         else:
#             path=os.path.dirname(htmlpath)
#             fpath=os.path.join(path,filename)
#             fp=open(fpath,'wb')
#             fp.write(par.get_payload(decode=True))
#             fp.close()
#     return

if len(sys.argv)<3:
    print '--input-dir=path --output-dir=path'
else:
    if sys.argv[1].startswith('--'):
        inputpath=sys.argv[1][2:]
        outputpath=sys.argv[2][2:]
        if (inputpath.find('=')!=-1) and (outputpath.find('=')!=-1):
             ipath=inputpath.split('=')[1]
             opath=outputpath.split('=')[1]
             if os.path.isfile(ipath):
                 ifilepath=ipath
                 if os.path.isfile(ifilepath):
                     (b,a)=os.path.splitext(os.path.basename(ifilepath));
                     ofilepath=os.path.join(opath,b)
                     if os.path.exists(ofilepath):
                         shutil.rmtree(ofilepath)
                     os.makedirs(ofilepath)
                     b=ofilepath
                     ofilepath=os.path.join(b,os.path.basename(ifilepath))
                     (fp,tem)=os.path.split(ifilepath)
                     (shotname,ex)=os.path.splitext(tem)
                     shotname+='.html'
                     ofilepath=os.path.join(b,shotname)
                     eml2html(ifilepath.decode('utf-8'),ofilepath.decode('utf-8'),b)
             else:
                 ilist=os.listdir(ipath)
                 for i in range(0,len(ilist)):
                     ifilepath=os.path.join(ipath,ilist[i])
                     if os.path.isfile(ifilepath):
                         (b,a)=os.path.splitext(os.path.basename(ifilepath));
                         ofilepath=os.path.join(opath,b)
                         if os.path.exists(ofilepath) and os.path.isdir(ofilepath):
                             shutil.rmtree(ofilepath)
                         os.makedirs(ofilepath)
                         b=ofilepath
                         ofilepath=os.path.join(b,os.path.basename(ifilepath))
                         (fp,tem)=os.path.split(ifilepath)
                         (shotname,ex)=os.path.splitext(tem)
                         shotname+='.html'
                         ofilepath=os.path.join(b,shotname)
                         eml2html(ifilepath.decode('utf-8'),ofilepath.decode('utf-8'),b)
                         # pst2html(ifilepath.decode('utf-8'),ofilepath.decode('utf-8'))